#ifndef GABA_DEFINE
struct connection_close_handler
{
  struct close_callback super;
  struct ssh_connection *connection;
};
extern struct lsh_class connection_close_handler_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_connection_close_handler_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct connection_close_handler *i = (struct connection_close_handler *) o;
  mark((struct lsh_object *) i->connection);
}

struct lsh_class connection_close_handler_class =
{ STATIC_HEADER,
  &close_callback_class, "connection_close_handler", sizeof(struct connection_close_handler),
  do_connection_close_handler_mark,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct connection_line_handler
{
  struct line_handler super;
  struct ssh_connection *connection;
  int fd;
  struct ssh1_fallback *fallback;
};
extern struct lsh_class connection_line_handler_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_connection_line_handler_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct connection_line_handler *i = (struct connection_line_handler *) o;
  mark((struct lsh_object *) i->connection);
  mark((struct lsh_object *) i->fallback);
}

struct lsh_class connection_line_handler_class =
{ STATIC_HEADER,
  &line_handler_class, "connection_line_handler", sizeof(struct connection_line_handler),
  do_connection_line_handler_mark,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct handshake_command_2
{
  struct command super;
  struct handshake_info *info;
  struct make_kexinit *init;
  struct lsh_object *extra;
};
extern struct lsh_class handshake_command_2_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_handshake_command_2_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct handshake_command_2 *i = (struct handshake_command_2 *) o;
  mark((struct lsh_object *) i->info);
  mark((struct lsh_object *) i->init);
  mark((struct lsh_object *) i->extra);
}

struct lsh_class handshake_command_2_class =
{ STATIC_HEADER,
  &command_class, "handshake_command_2", sizeof(struct handshake_command_2),
  do_handshake_command_2_mark,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct connection_remember_command
{
  struct command super;
  struct ssh_connection *connection;
};
extern struct lsh_class connection_remember_command_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_connection_remember_command_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct connection_remember_command *i = (struct connection_remember_command *) o;
  mark((struct lsh_object *) i->connection);
}

struct lsh_class connection_remember_command_class =
{ STATIC_HEADER,
  &command_class, "connection_remember_command", sizeof(struct connection_remember_command),
  do_connection_remember_command_mark,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct connection_if_srp
{
  struct command super;
  struct command *then_f;
  struct command *else_f;
};
extern struct lsh_class connection_if_srp_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_connection_if_srp_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct connection_if_srp *i = (struct connection_if_srp *) o;
  mark((struct lsh_object *) i->then_f);
  mark((struct lsh_object *) i->else_f);
}

struct lsh_class connection_if_srp_class =
{ STATIC_HEADER,
  &command_class, "connection_if_srp", sizeof(struct connection_if_srp),
  do_connection_if_srp_mark,
  NULL
};
#endif /* !GABA_DECLARE */

